GNU bug report logs - #57397
29.0.50; cl-letf blindly macroexpands places

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Michael Heerdegen <michael_heerdegen@HIDDEN>; dated Thu, 25 Aug 2022 04:43:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 18:15:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 14:15:46 2022
Received: from localhost ([127.0.0.1]:34583 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odbb0-0007W4-Kg
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 14:15:46 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:59553)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1odbay-0007Vm-IL
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 14:15:45 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id DEC8C1000F8;
 Wed, 28 Sep 2022 14:15:38 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 9184D100138;
 Wed, 28 Sep 2022 14:15:37 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1664388937;
 bh=eMgj8UsbfS6mEijlofPX0DTuzv2re8eW5k09IgcfT48=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=cNEQg/eVrBohAbQB+hTfPnaI1cAG/ncMmshjU3tUjBgPevS1GI6AFahN/QsY0lPIv
 p+ogHugGqzq7Kh26Nv+0oG0/s4xcCBGvlU0LHsirmsUtG+3QYbjwkQQILYVMZxDMKm
 RlbP2QU8VLnkOz1ueZam7sDR7gIyRB3h5BGy5+xoT5UPwsH0x/sg1D7NfFkOlczjgH
 b+IeeMewTuW9kwjRHyQOGVaFZhW8DuKR83kHEc1BE9MaATFtE/cDJIkcmlcbKnIYnx
 IqgoGHbNbivdinddlzp+U9hmjunLeQDDPqqAU1Sjl26TbD0pg1SEt1jREFfZ+d4+j1
 Gt3T93mjcraMw==
Received: from lechazo (lechon.iro.umontreal.ca [132.204.27.242])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 767BE120A16;
 Wed, 28 Sep 2022 14:15:37 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#57397: cl-letf blindly macroexpands places
In-Reply-To: <87k05n1iy7.fsf@HIDDEN> (Michael Heerdegen's message of "Wed, 28
 Sep 2022 19:56:32 +0200")
Message-ID: <jwvr0zvtlfq.fsf-monnier+emacs@HIDDEN>
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
 <87tu4rbj1t.fsf@HIDDEN> <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN>
 <835yh7igr3.fsf@HIDDEN> <87o7uz1l24.fsf@HIDDEN>
 <8335cbifog.fsf@HIDDEN> <87k05n1iy7.fsf@HIDDEN>
Date: Wed, 28 Sep 2022 14:15:36 -0400
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.166 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Michael Heerdegen [2022-09-28 19:56:32] wrote:
> Eli Zaretskii <eliz@HIDDEN> writes:
>> Then just say it, in these very words.
> Ok...could you please rethink your change then, Stefan?

Hopefully better now,


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 17:56:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 13:56:55 2022
Received: from localhost ([127.0.0.1]:34550 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odbIk-0006yr-RL
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:56:55 -0400
Received: from mout.web.de ([217.72.192.78]:44561)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1odbIb-0006yU-0O
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:56:54 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1664387796; bh=LcIR8j05D3hwxuQ5qpngksyroHllPjVlBf4ZeBGepUg=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=wYml92aVoJy+PkBCXysx/VRe0pmBDVfwUkk+4BQO0bOJP5ScGto5TYlKCsaDhGTrM
 Re9Ky4LYxwVAf1gPpNKnLmfn5f8LBtR1mKMNCONjkbpRoSgv4EeCkS0v856pK4NBCC
 BpUndI7HUbqtjqCKNQnXHUZlQZf1tw3aRm5k+fd9aw3PZXoWKV8P/q4fGBprfvF5z2
 /n8Bl6mu629RHePgy3P/MMu/Ev88QasBENCLlMUwZE2p9roW5cPweBqFSEC7saYufW
 1hTa7t3wIcy7cJnRWeM83UP/1cOrIh09Y4SdgiR4RlmYRjrl5d3dSoMY/Vb/mJh/bG
 B+k/sak87M7jQ==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([94.222.172.180]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MTfkd-1onsII2rm9-00To75; Wed, 28
 Sep 2022 19:56:36 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#57397: cl-letf blindly macroexpands places
In-Reply-To: <8335cbifog.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 28 Sep
 2022 20:15:11 +0300")
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
 <87tu4rbj1t.fsf@HIDDEN> <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN>
 <835yh7igr3.fsf@HIDDEN> <87o7uz1l24.fsf@HIDDEN>
 <8335cbifog.fsf@HIDDEN>
Date: Wed, 28 Sep 2022 19:56:32 +0200
Message-ID: <87k05n1iy7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:ZyiezSOXubu1BVaRIG4n5BicqMgEc3unO7zsCNYzyldXrVlvqtW
 wdCUaou61yvGw3lwa0BKqzuBNoY/kV4R2Q3QMsBqNjmXpHYONGU93ocHJQfKIz485LApnBY
 4JBmoB2Mh78JA2TWooxVfUHFsbZ8ekTtPK4D2th8P4htPzroIem41vx+s6/Hhp0FQO0LNHc
 mVVewCovZF/GqMxgkk2DQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:KblSsRJExzI=:7FIloPjLJS6fXzDpijY0vh
 ovZ2u16Cm7WG96ckbJDkkU92Dol0qBr6qNy5Hw5ub4JpAC01e7wh1qC8+YXAxmHIrURpfGd49
 vszYU8SY93YnIO6vLuJ6YQmu1HaqQcVUfCbj2uFvYDONCkJrJUSa5lNtcOA/nYoSv3OLkW9Sq
 qPIKJUZQm0CXtpt/zsHZGHK7XqSmDiBhJx+tJ+hIVwXpHJWTjqJvmsrI3BNFOXW9oFR5BQOIt
 Jf85y1qHTmYfXYdSrKfC9/Z4rClkIP3KQsvLKOnszUXWXIhOEQ8FXTghI1xuh76zN8rOprmie
 nFPZ8ajV2avGopUql5gJcPlvVb7XZLdswcActuKpN2xDAMKmJR2VrkyQAcVNd+SVa8041DUOu
 68PyWzscQ0zkvTXUglPcI3wFIt3TqfUJTZSuU900crdMByTmtsT1frf/hOZFXTn9KnKBQt9+d
 xDBLOZPYqhw9GogrO4XIWks3LdQcTOx1t5xvWhfy2CXcpbWHOZ1Pa5UrtEIdr2UNEDLVzUun7
 nlgAFvAwsJKaUTJCuCOA+EiXykLMgi/+93MMo2THijUgnriyRg5zoExfzhB49YM3zY2O9VAC+
 XfVvkReMHUOW7gdlpC18CHK9+s3D9AYpiLphqEzpL8+edOkjaOIRY/Qu5ObOPQOM9KxBQXol7
 wTZ3J+jpLMoDI81ABsuBKZcsy/RZEbmIM6+QvltKLk0gi9EJURaqJ6wEkLg2NeDdJ7AdRSCH9
 s67qCKZUUif6G6vrlm6LDFCb0RQXzBk2P8jxA+ea7eZQxYa4AJqb/IE07ohbTxp4o9v2e6eAJ
 zTZg1eFlxuVUzG/g/NdAD16TSEt1/KAI/J1TSABASPyznX+9UiENVWBmBmYLpBAtWbjNGA7HR
 fhSsLJHwk5JgW3jr2IKsh8FPZMXiT0qvmCKxT0lZpWyACnjeM3qEMfmy0kH/jdDpQc8EWBtaG
 ooXiXo6ZHcr3/naeKbda5syQE6hHYaaRcn2wZvbE9svQgzveUOFGu5IRaAqsBZ/tvk+XTVIMV
 2ztjlzo4ZhmB/HURBrZAZ0u+uzXsxHzEEK2tQti4M66Mtx1htz7nWY6wkvZcKCf2laITOp9aY
 JKiINOGJFrJp1vagEwQfvVzLN2uG8Vpx+TmR3AA3x3FDZJc+xDPSV87KxDmqGfqlt6vTuXtje
 gQtOPH7OROwfpPr/U2HGTej+Sj
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, larsi@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Then just say it, in these very words.

Ok...could you please rethink your change then, Stefan?

Thanks,

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 17:15:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 13:15:29 2022
Received: from localhost ([127.0.0.1]:34486 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odaee-0005vD-T5
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:15:29 -0400
Received: from eggs.gnu.org ([209.51.188.92]:43960)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1odaed-0005v0-HV
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:15:28 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:52622)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1odaeX-0006qS-Nu; Wed, 28 Sep 2022 13:15:21 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=References:Subject:In-Reply-To:To:From:Date:
 mime-version; bh=aTGLExXNmdpGnD95z0C+0wHJCbZULBMvkLC3hO/1AEE=; b=etpgV8ICmCx7
 42ZwxksoInXzpifc8NHESf157K0cLTIqhzIyUmfpvF33aMdP4H5nOg62ABaMI/3iYawpsZUXTXFRS
 ZGxQqbnd5lI683kmp4xsyl0I6NJnRb1qTb2S/u9cHcDABZ1kdj4w+5p+icqsJpip+JCo+dCvy2Qfz
 GPsWG8dWqa5hgO72OarQk06WiezLVDeoDqpNWPM8qFfKoEjoeb8sG2pK4ew6NuDlBIgbOWZP2ABbk
 2ZMi6fRCE3WAjxMLKob8lSOiY+2Msh0ujMa5bspA7po9MZKWyXKZCNz1KuLfu7FhohVrn4KQNULGI
 usGhrLt9X6/QqQype+VRBA==;
Received: from [87.69.77.57] (port=2256 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1odaeT-0004xa-TW; Wed, 28 Sep 2022 13:15:20 -0400
Date: Wed, 28 Sep 2022 20:15:11 +0300
Message-Id: <8335cbifog.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
In-Reply-To: <87o7uz1l24.fsf@HIDDEN> (message from Michael Heerdegen on Wed,
 28 Sep 2022 19:10:59 +0200)
Subject: Re: bug#57397: cl-letf blindly macroexpands places
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
 <87tu4rbj1t.fsf@HIDDEN> <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN>
 <835yh7igr3.fsf@HIDDEN> <87o7uz1l24.fsf@HIDDEN>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, larsi@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Michael Heerdegen <michael_heerdegen@HIDDEN>
> Cc: Stefan Monnier <monnier@HIDDEN>,  57397 <at> debbugs.gnu.org,
>   larsi@HIDDEN
> Date: Wed, 28 Sep 2022 19:10:59 +0200
> 
> We needed to say more clearly that the given lambda form must have an
> argument list of exactly one argument.

Then just say it, in these very words.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 17:12:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 13:12:57 2022
Received: from localhost ([127.0.0.1]:34479 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odacD-0005qc-Cs
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:12:57 -0400
Received: from quimby.gnus.org ([95.216.78.240]:37086)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1odac5-0005q4-0j
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:12:51 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:Date:References:
 In-Reply-To:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=eIzT9iGegqUlZv/+eCkILqZj9dZKSSZEEyYpH9ocsjY=; b=VQkvmtg1t5Vw9xUFL94kDpzfrA
 Sb7DCkaAYOMVZGEiRefaksB8u6WkTzVrWNL5lUDNBJFAkcjHjgkmztpOpmdySWb1Bv8caKW1+niaU
 rNI78ytECIZnhRdUyACEk8BDqym2xQIh9uhEdGRJCF0Nr50opmxB8XfouRIkWuKGL0yo=;
Received: from [84.212.220.105] (helo=joga)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1odabu-0005hk-JQ; Wed, 28 Sep 2022 19:12:40 +0200
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: bug#57397: cl-letf blindly macroexpands places
In-Reply-To: <87o7uz1l24.fsf@HIDDEN> (Michael Heerdegen's message of "Wed, 28
 Sep 2022 19:10:59 +0200")
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
 <87tu4rbj1t.fsf@HIDDEN> <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN>
 <835yh7igr3.fsf@HIDDEN> <87o7uz1l24.fsf@HIDDEN>
Face: iVBORw0KGgoAAAANSUhEUgAAADAAAAAwAgMAAAAqbBEUAAAABGdBTUEAALGPC/xhBQAAACBj
 SFJNAAB6JgAAgIQAAPoAAACA6AAAdTAAAOpgAAA6mAAAF3CculE8AAAADFBMVEXe0sSdel48JR3/
 //8L91rsAAAAAWJLR0QDEQxM8gAAAAd0SU1FB+YJHBEMCKSc1hAAAAGISURBVCjPTdK/btswEAbw
 j4IVIJsMyAWsJyj6FHSQGGgmpTCFSLNtxHwKL901mB48aTAF8XvK3skFWk766f6AdxIWxasBrIUe
 RQ5bb5abB7JCUPxFXthiWawWM7AATCE1brV0Dh/GObcD6cnfDCQTPDvyxnB44Ha7ki76GbERNOyO
 E46cqlETm3oQpFKLfZAbtZ6l9OOVHxZtRSfPjGwA/8J3RRpHQZ9yTZOYxWFYmypqKL5h+P5sfGjI
 Ma0xPT8Zpl8aKtEZkzEtpSzusDkji5+r9xl9gWzAekuGHU4yZI9v0iFekFtFJhdPFrYUWPNCtrUk
 AT2QyXxy7RwIwBPZWdyNRXNWXGsQO+Q1KkEPnve6Q2nNARyc9DCyL94FrZ3ryR38vbdf0AAvst6+
 YRAkvgri0ad5cCtIh1OaV2JlvfRBAyktoO+cIqxLxRgV7uc/JPf2qQ26JJ2D2yaNRIVzzSS47OVT
 Rec6TZv2fkb7JTj1P4KUPNJOtopJfoOtjJDaupIkwRn/nz/A5eciy6xF5wAAACV0RVh0ZGF0ZTpj
 cmVhdGUAMjAyMi0wOS0yOFQxNzoxMjowOCswMDowME1Im5MAAAAldEVYdGRhdGU6bW9kaWZ5ADIw
 MjItMDktMjhUMTc6MTI6MDgrMDA6MDA8FSMvAAAAAElFTkSuQmCC
X-Now-Playing: Kate Bush's _The Dreaming_: "There Goes A Tenner"
Date: Wed, 28 Sep 2022 19:12:35 +0200
Message-ID: <87bkqzxw1o.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Michael Heerdegen <michael_heerdegen@HIDDEN> writes: > We
 needed to say more clearly that the given lambda form must have an > argument
 list of exactly one argument. I think you should say exactly that, in those
 words. Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Michael Heerdegen <michael_heerdegen@HIDDEN> writes:

> We needed to say more clearly that the given lambda form must have an
> argument list of exactly one argument.

I think you should say exactly that, in those words.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 17:11:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 13:11:15 2022
Received: from localhost ([127.0.0.1]:34472 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odaaY-0005nw-NR
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:11:14 -0400
Received: from mout.web.de ([212.227.15.3]:60493)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1odaaV-0005nh-Ls
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 13:11:13 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1664385062; bh=82UJMikLprOLx0LcqX0nFbZrLgnVyqfjwEEGXSBE7ao=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=Ibw6dPUc+C1lJl+1EPY1Pujuxo9Uf+fW3H2wcG2t2j7mlhSLGRnVWWaWQK6aa6ccK
 J65GwxIvXPHlxFkCe7iLMsdm79AXXGMA+5WHsWKWCx7qOiQKggaK8enQRjdQvlu90G
 K47Hrsb2AP/Kyi2DrnEqo9rBrCSIRqw4sT/CieqOVh2SKTQqevhqDM2OQ//40Rw4A9
 7lYp/Hhxfx9Fu9f9y92QFVHe+FBE6/7j4nUSCf4WMla8DhPP59MxGKFBFJ/5YTN6fw
 uF70oVSavJC4wPQu+AvFOgmwmOrmWjVN4KlOEF6gXJyFY+vP7lFLBtPQnPIwx7HboY
 LuRfmo6KNHZHw==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([94.222.172.180]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1MkVsg-1p5Y8h3bHK-00lvij; Wed, 28
 Sep 2022 19:11:02 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#57397: cl-letf blindly macroexpands places
In-Reply-To: <835yh7igr3.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 28 Sep
 2022 19:52:00 +0300")
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
 <87tu4rbj1t.fsf@HIDDEN> <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN>
 <835yh7igr3.fsf@HIDDEN>
Date: Wed, 28 Sep 2022 19:10:59 +0200
Message-ID: <87o7uz1l24.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:SPF+V8yvhOxZIo5hXEcs8YmMoGDG3EjdlBuWkbayzgb9jQqeVul
 NyLBLHsAxOJTHOOY4X+ALeLMWs/9fmPEBjG0qSkknnlQEYKTiyQ4/I3ELEfQy9KLUav8lis
 aeUCCvfzzEz/6C6+/wFPtR9ewn5IsfwF8/CtCglQOKcx2MCYuOFcPzZSqGNUHB454MBGwe/
 cXHszfG1C8R93DLong1DA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:n2tfxznZVT0=:kiWXPltA+hwXSHGkNUqQKF
 2R6OaO1VORG8Htt7SP1HR5vX5yeY/3YXQZYFUhxfpVT+6qsYLYXx+aVYTJIXI6hhAGUi0u/Ra
 gdp3p+OkhjBUtYjVm+ioXiffdOC3nLHsfoYYDMlGYZHfuSI7pBpE/pq7pJ+9YLfVsL4SrI9aO
 +wvpl7HVcYJ2isjQf5DzDM3P9XJKYDnQ/1jtbqsJSjsj4vSUOjFGO65NsPQYMeZpBzG32yAru
 w6QR1pny/XxJrhZYoTCXlrAdb5kpP4RwQPFi76rjKLPGPKwSHQUQCzMOuVlIOmekgdumcNiw3
 yy1pFyRuz+f9B7w8dYUrCb4kgdEueDe3fX2zlkheUFsLL7kIb8P3A4Ev6NDXcIkz+5clGIh4p
 uvd2jbABLSPnJflq2AsYlrvGvLNXy98BtWFc/IjbLWxU2LvWeCsdr4uFDmv+ZQnAgR0AIGUWt
 Fh6ABercrKRc9sAUm3IJvm4XeTHwWy4AJ0ydyb/JTwkwe1RkeHDYLWkg5e8ogx8Sbb40yKpeV
 C1RjZbPU5AvpGMRaOihlS/Dj61I/+QphZD8nPH+MJxOOXMAzPAJHXmoFTO9jnrEIRr2AYepLV
 NiZF01o34i+uoKqjEr3o/B0RWjy/8bAwuWF6PDybPLNS1qz/pGjy1zyINt4+HbjvMWOy1+Kd/
 46W96Lmjfa6jQ3ajyRl0C5XUjf8Cn3kL2JsqaOuYXJMsznEtqWWJaAL3sYkmOqVl6YAtWy9jv
 wcKnNsyMAtgIUATWkkRjbKyny/jhrwmAa/GuAPGNQgST/p2XOo2jAEk+a36q3OFvO53dqDV/5
 qR6MVxqq+srIdsCK+6647kjXCitbHpWLzUbO3W97HPQK4nuz0kBv9CMf3tHi3RAVyiR//8hFd
 SWPCqGmvc6DYbl2yucgh8ZxEl48Y0/UecRWi4JOqS4qvoRdG6E8O/pZ2ivSO/M04Me7jE7Fdo
 mnJP07cmdUBdWsC29T6scer0/wokT2i9opUe628ZDdaSB37zumEv2OFzorHce4bT5N6BW2kWO
 +EpjEiqOG2btfISjdF/DNvN1WChvXxsYUiBQe7850Nvfev5NYmW8d+/jtDFlbHZiCGbjiZxLk
 3cOGycSBWupdGYYPCesQC1aEGDD6L4Rmq2pbST31oYEgnUjNfm9/meg75DUa2sJAUqd/mj+60
 pWhOFSz/8r7uDkfrkrQ42dLknT
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, larsi@HIDDEN,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> The original text was somewhat more self-explanatory:
>
>  To avoid syntactic redundancy, when @var{expander} is of the form
>  @code{(lambda (@var{arg}) @var{body})} the function's formal arguments
>  are automatically added to the lambda's list of arguments.
>
> This explains the reason, and actually reverses the cause and the
> effect, which then make sense.  (Although the issue with the form of
> lambda still stands.)

Hmm - I liked that wording more, too.

> What am I missing?

We needed to say more clearly that the given lambda form must have an
argument list of exactly one argument.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 16:52:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 12:52:18 2022
Received: from localhost ([127.0.0.1]:34441 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odaID-0005J6-Nn
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 12:52:18 -0400
Received: from eggs.gnu.org ([209.51.188.92]:37268)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1odaIA-0005It-Ip
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 12:52:16 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55086)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1odaI4-00029w-Dy; Wed, 28 Sep 2022 12:52:08 -0400
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnu.org;
 s=fencepost-gnu-org; h=MIME-version:References:Subject:In-Reply-To:To:From:
 Date; bh=Z6w2YwhjUY1YcTMeLkE4PoewDQXchE3AUPimPESf1jY=; b=AcUyPUsLJD8q6p/oqGut
 39usNLd3CWJFIsFyJt3RtdP++8mKjtY6l6N5dHKKG2EvYnTEcroB+im8ecyuddK6AM0hVPTKxLTI7
 3g2iD4+1FuOqa5iPafHuo1UP4uvyTr5sHKcu7jb0PyP/rypigDGVV7uv6xsK2Rd3XO+XlYNBEqjdx
 xNbCMMDWWfT6e3qH0FCZq+AoO9KQKEdr6JNjflOidpPb3cUXFES3kbqnN1Aga6zVWsc4nC3w5ihA5
 ZjSWgO4Ac+Cr65gBsfeUcnX45a76GwaesxxXVmlHlMZMU8R0XTHtrrC6y5TF2j4dSKIqgrcTSi263
 CbJobEhSiWJzBA==;
Received: from [87.69.77.57] (port=4818 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <eliz@HIDDEN>)
 id 1odaI2-0004Ny-P7; Wed, 28 Sep 2022 12:52:07 -0400
Date: Wed, 28 Sep 2022 19:52:00 +0300
Message-Id: <835yh7igr3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-Reply-To: <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN> (bug-gnu-emacs@HIDDEN)
Subject: Re: bug#57397: cl-letf blindly macroexpands places
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
 <87tu4rbj1t.fsf@HIDDEN> <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57397
Cc: michael_heerdegen@HIDDEN, 57397 <at> debbugs.gnu.org, larsi@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
> Date: Wed, 28 Sep 2022 12:29:20 -0400
> From:  Stefan Monnier via "Bug reports for GNU Emacs,
>  the Swiss army knife of text editors" <bug-gnu-emacs@HIDDEN>
> 
> > But could we maybe describe that simpler like "when expander is a lambda
> > form [...]"?  - Because AFAIU these arguments are added to _any_
> > argument list - with other words, implicitly hint that it's an error to
> > specify function arguments in the lambda arglist explicitly, or to
> > provide an empty arglist.
> 
> OK, thanks, done,

IMO, the text which was installed looks devoid of any useful
information:

          When EXPANDER is a lambda form it should be of the form
          ‘(lambda (ARG) BODY)’ because the function’s formal arguments
          are automatically added to the lambda’s list of arguments.

Isn't every lambda form _always_ of that form?

And "because" is out of the blue: there's no cause and effect relation
here that I can identify.

The original text was somewhat more self-explanatory:

 To avoid syntactic redundancy, when @var{expander} is of the form
 @code{(lambda (@var{arg}) @var{body})} the function's formal arguments
 are automatically added to the lambda's list of arguments.

This explains the reason, and actually reverses the cause and the
effect, which then make sense.  (Although the issue with the form of
lambda still stands.)

What am I missing?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 16:29:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 12:29:36 2022
Received: from localhost ([127.0.0.1]:34416 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odZwG-0004hl-EG
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 12:29:36 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:43037)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1odZwD-0004hV-Of
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 12:29:34 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 0B9DD100130;
 Wed, 28 Sep 2022 12:29:28 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 667981000F8;
 Wed, 28 Sep 2022 12:29:22 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1664382562;
 bh=GJREESx5FQmg+FK1ktMz5OiU64Ss0USvHLRuZjeAnxQ=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=AXQBh2UplhrdodukzkuidNshOrwfN05C3j1YrY5p8Jn4YR3aubyHM6OAs/8QzFf1F
 SgXm+7ygwYxtx+wJ20LT04EIwrTqiUcLJI2H/iAWU5W5CRY96CWWqepnhbFqSd7ldV
 BDcicHqNGp6OL6uCw233zlgs02kX6gXaSOROohRv4biPYYBEu1/qYK/HBx/kxy5J4x
 NJax26Y5kjoYARTDU+8ho+SD7dVusUu2cGJwN+GnR/XeXMdoff1A41E05loHPZM7TR
 pbxC3sc582+0mzSqFbTMhK+H2iv43SRbSjIZje9HnDX0ANX2+N8fx7dvSzoYmL95ZC
 yKOZuzVHVJ2Zg==
Received: from lechazo (lechon.iro.umontreal.ca [132.204.27.242])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 455EC120909;
 Wed, 28 Sep 2022 12:29:22 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: cl-letf blindly macroexpands places
In-Reply-To: <87tu4rbj1t.fsf@HIDDEN> (Michael Heerdegen's message of "Wed, 28
 Sep 2022 17:44:14 +0200")
Message-ID: <jwvczbfv4x6.fsf-monnier+emacs@HIDDEN>
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
 <87tu4rbj1t.fsf@HIDDEN>
Date: Wed, 28 Sep 2022 12:29:20 -0400
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.166 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> But could we maybe describe that simpler like "when expander is a lambda
> form [...]"?  - Because AFAIU these arguments are added to _any_
> argument list - with other words, implicitly hint that it's an error to
> specify function arguments in the lambda arglist explicitly, or to
> provide an empty arglist.

OK, thanks, done,


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 28 Sep 2022 15:44:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Sep 28 11:44:28 2022
Received: from localhost ([127.0.0.1]:34251 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1odZEa-0003Sl-CA
	for submit <at> debbugs.gnu.org; Wed, 28 Sep 2022 11:44:28 -0400
Received: from mout.web.de ([212.227.17.11]:41463)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1odZEW-0003ST-TK
 for 57397 <at> debbugs.gnu.org; Wed, 28 Sep 2022 11:44:26 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de; s=s29768273;
 t=1664379855; bh=QmKPWlX4L/A5lcm9eCmcTCs/syL91oxlghApVLDcvpQ=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=TpGrT3Ca7x16lxMIGhAW7R3KOAMvqeM2aBsBLaXKx5aBKhuTE9fnzPXMt0rBEUban
 SOsTzs/INYtQAxQW3J6AMqE0MZM76xSq/aBA5g5DNhDt33Uz8RnOXKMS2Zk+bJfO3t
 Yi7kcRqaxh05/FrKWMOPNJeb9Yb9Zh3EBHe0YbZqYhY01tQfYJpbAkDxw2WGr0BGiZ
 HcemzcjFIrGxvlgFUPWKC79zoRUKz9FWBo4H8HqPvTMd1I8Lx5b4TPVova7+JtrFxW
 xHv5do5fOIOi8soF1J9hSad07tUzF63Fqg2ZAcaVm6TpGDxwpYn7Y9P6eHUqIxzYPJ
 hYIX34Jhr6VOA==
X-UI-Sender-Class: 814a7b36-bfc1-4dae-8640-3722d8ec6cd6
Received: from drachen.dragon ([94.222.172.180]) by smtp.web.de (mrweb106
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MZSFY-1ohKiP1Nbi-00Wr3L; Wed, 28
 Sep 2022 17:44:15 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: cl-letf blindly macroexpands places
In-Reply-To: <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
 of "Sat, 03 Sep 2022 22:55:53 -0400")
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN> <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
Date: Wed, 28 Sep 2022 17:44:14 +0200
Message-ID: <87tu4rbj1t.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:iIBx0oLLr77+d4816t4S+Yrlz8MMK4p4KG1f4/WG8fi6wEVxavr
 LKgsblDyLavLxJw8u+T4TEXmxqhDaJJ8y63btGeAtPKkVwZk9LBnzSgB4xvER0voPi+pDQK
 wtpr0A3RLxmh111GSl9nX5xcUQtxU5/htZX579pZir4Mb2XTHKSngNd1Iz8RTgqh04lebhq
 trq1sitrypJDnWU+ahchA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:WYhEArP8xr4=:07vJ29KQ1MxYTlUFMPGoq6
 +fNPHiu++W51FnlsCJkxOsqrdQe6wl7fJSgjle971SElTOvrWbeD+nL/XkrWnNUNVL8thtcGX
 kQdymjzhdDGTluuTbkXskBnnS8qhgVkkGy8SJR5WxINQgA4/EHLxbySM/83kCjk+m0w2nf5+n
 uRv701M9Au3We7rOeWGS04W0PyNUx/hG1iA8BRT4qRLSJ1F8x2j2c/9YRxBhM/Nurd26zSnrH
 na2VC7RwQSR5QgE0QhEpK9ECk1KmoKtt1z48jc+7ee+UKDy/NLOKUKhgE63Ye1jyjWra53qIU
 DESmsy53k/LDOLRwx/L9E3494UB2WKgoCtR43QvNul5jIEplJ7Jdn0w+BTaQwMQgQ0iqK9Nji
 R4lzezX+Gfcy64TncavaY3R4BzFoFlTIOj/lMxFHAq80HJyOXkQ43ipE1spXntaagnhCY+l3Q
 UOLkr+sJlOvVubzb/9E/UPI8cCwWG0XyYAiTvi7o2umeRAAjvyT/NHiAgmcNiXDpmfsGtjb3a
 yrdHio1AkKzRg2R8MAU2c3jeiQgujWrwDdy0GgSODtMNNMnJO9xPa/xCddBDLCgXwdEix4Sg2
 dg/Sr7Tj7LXDwwoX76fQTPKQYv1U0oa9Di8gBWepYCUR/g5Kg1VAfHggouXK9vi72MCQ2pB4C
 f+vkwh3AHRmladIGhNtOQsX0LexYCfEG1L9werTdeAGVihJQp696cA5GOlpaiXWO5RSXVDBf/
 xoCCePlq7eYvkoGFhVuUXMs6hHHkqJW/T4/sfOG9bqOOyrwas0SzkmaohKxmIKl5kIXtUx2eR
 dQVrIy0f8Xd0YVGj2TaQNRMX+T6puaGTWdBFtEajRe95ZfLfys94MvsZYMd07zCk6I505epK+
 JnBBDLqZFIgJsTmiyz2ZelAedKAyuMjFjqNJdy0uQDYBFJGekJ7LfEKz8UhTFPAGj3MAETERc
 fUIEPNdUG4QD1DgxP7/590SXvQrREww4gwv1SEtgvufFxPPWDEg10WyAyIzRPxTI6rpPNtJtx
 K4el5WgB46EyNMsWhbQ9SaFSYqlzEyTSiHoklx6wUXdRPeEr+gg54zgLOxz1DN1r9/u9wuPMQ
 XNdjnNaxwM9dKkmNeBZTyMBXVMrgYQfGZXfG3x4QlwlPzcMoGF21ssOpOhF0vXSVsqTGZMufD
 QlclHaz9VLw/gbOa3XW27Fd0c+
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Monnier <monnier@HIDDEN> writes:

> diff --git a/doc/lispref/functions.texi b/doc/lispref/functions.texi
> index 983dfe2ec59..8e34fdf3640 100644
> --- a/doc/lispref/functions.texi
> +++ b/doc/lispref/functions.texi
> @@ -2476,11 +2476,11 @@ Declare Form
>  expander will call @var{expander} with that form as well as with
>  @var{args}@dots{}, and @var{expander} can either return a new expression to use
>  instead of the function call, or it can return just the form unchanged,
> -to indicate that the function call should be left alone.  @var{expander} can
> -be a symbol, or it can be a form @code{(lambda (@var{arg}) @var{body})} in
> -which case @var{arg} will hold the original function call expression, and the
> -(unevaluated) arguments to the function can be accessed using the function's
> -formal arguments.
> +to indicate that the function call should be left alone.
> +
> +To avoid syntactic redundancy, when @var{expander} is of the form
> +@code{(lambda (@var{arg}) @var{body})} the function's formal arguments
> +are automatically added to the lambda's list of arguments.

Yes, that would have helped a lot.  A definitive improvement.

But could we maybe describe that simpler like "when expander is a lambda
form [...]"?  - Because AFAIU these arguments are added to _any_
argument list - with other words, implicitly hint that it's an error to
specify function arguments in the lambda arglist explicitly, or to
provide an empty arglist.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 4 Sep 2022 02:56:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Sep 03 22:56:06 2022
Received: from localhost ([127.0.0.1]:43230 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oUfnq-00038Y-DS
	for submit <at> debbugs.gnu.org; Sat, 03 Sep 2022 22:56:06 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:5779)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1oUfnm-000380-7u
 for 57397 <at> debbugs.gnu.org; Sat, 03 Sep 2022 22:56:04 -0400
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 6D3271001D2;
 Sat,  3 Sep 2022 22:55:56 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id D4A30100154;
 Sat,  3 Sep 2022 22:55:54 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1662260154;
 bh=oAuGiVhznoXWGrLkJzjHIx7hhxuKbhGRYXrIPJyFk3k=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=Th3nbxc4EbZX5lqj4DLi02thRpGJF0vB629H4oZSlqrkEIIc0w9hhRz00qAmUnNwL
 tjq0t6cUFtoOdSKQW0QvPWVHnSjUcgZs+4a0Vy+Zaj0Z+C83jl9q0psm1olrtGNVmK
 wg7Iokv23XATJwf4q77Yx8nEH7jwVK7RjT6E0byGp99F8OIC2wWDaf7FAnRf3NpN8h
 h3L+Tzs2KMotHBdgzUiSyRRMZvwlw2TgG9h4db06yM0CG26Z9vqzj8/BNw7sAzqvDp
 Ba7Jfz0MCvYt4vP/lPSY7+JPkdYUCCTwEKVKDwdF08NCMeV2WW9LYSBR9JFqzPc5hV
 tIDWCrwq1Ystw==
Received: from pastel (unknown [157.52.9.190])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id A9776120840;
 Sat,  3 Sep 2022 22:55:54 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: cl-letf blindly macroexpands places
In-Reply-To: <87sfldmc43.fsf@HIDDEN> (Michael Heerdegen's message of "Wed, 31
 Aug 2022 03:32:28 +0200")
Message-ID: <jwvo7vvx3rg.fsf-monnier+emacs@HIDDEN>
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
 <87sfldmc43.fsf@HIDDEN>
Date: Sat, 03 Sep 2022 22:55:53 -0400
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.043 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> No the problem shows up in the `gv-letplace` that follows immediately,
>> so by the time we get to the `symbolp` test it's too late.
>> But I suspect that the better fix is to skip the macroexpand call here
>> and to change `gv-get` so as to do a `macroexpand-1` call even if its
>> arg is a `symbolp`.
>
> Ok, you have obviously more insight here, so can you maybe...take over
> this part?

Pushed to `master`.

> Ok - does this look correct?

Looks good, yes.

> BTW, I had trouble understanding the paragraph about the compiler-macro
> declare specs in (info "(elisp) Declare Form"), in particular the calling
> convention:
>
> | [...] When encountering a call to the function, of the form =E2=80=98(F=
UNCTION
> | ARGS...)=E2=80=99, the macro expander will call EXPANDER with that form=
 as
> | well as with ARGS...
>
> not only because of the colons, but also because it's...wrong?  EXPANDER
> is called with one argument, and the other formal arguments are
> available (bound) to the corresponding argument forms, right?

There are two cases: one is when EXPANDER is of the form (lambda ...)
and the other is when it's not (in which case it'll be a symbol naming
a function defined elsewhere).

When you write

    (defun my-foo (arg1 &optional arg2)
      (declare (compiler-macro (lambda (whole) ..blabla..)))
      ..toto..)

it is macro expanded to something more or less equivalent to:

    (defun my-foo (arg1 arg2)
      (declare (compiler-macro my-foo--expander))
      ..toto..)
    (defun my-foo--expander (whole arg1 &optional arg2)
      ..blabla..)

> Could you then maybe rephrase a bit [I don't want to, my English is not
> good enough.  I'm able to do it but it always takes much too long to
> find a good wording.]

I can see the source of your confusion, but I'm not sure how to write it
better, without making it much more verbose (and risk making it yet
more confusing).

Would something like the patch below help?


        Stefan


diff --git a/doc/lispref/functions.texi b/doc/lispref/functions.texi
index 983dfe2ec59..8e34fdf3640 100644
--- a/doc/lispref/functions.texi
+++ b/doc/lispref/functions.texi
@@ -2476,11 +2476,11 @@ Declare Form
 expander will call @var{expander} with that form as well as with
 @var{args}@dots{}, and @var{expander} can either return a new expression t=
o use
 instead of the function call, or it can return just the form unchanged,
-to indicate that the function call should be left alone.  @var{expander} c=
an
-be a symbol, or it can be a form @code{(lambda (@var{arg}) @var{body})} in
-which case @var{arg} will hold the original function call expression, and =
the
-(unevaluated) arguments to the function can be accessed using the function=
's
-formal arguments.
+to indicate that the function call should be left alone.
+
+To avoid syntactic redundancy, when @var{expander} is of the form
+@code{(lambda (@var{arg}) @var{body})} the function's formal arguments
+are automatically added to the lambda's list of arguments.
=20
 @item (gv-expander @var{expander})
 Declare @var{expander} to be the function to handle calls to the macro (or





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 31 Aug 2022 01:32:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Aug 30 21:32:46 2022
Received: from localhost ([127.0.0.1]:37784 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oTCaz-0006ju-OO
	for submit <at> debbugs.gnu.org; Tue, 30 Aug 2022 21:32:46 -0400
Received: from mout.web.de ([217.72.192.78]:53667)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1oTCau-0006ja-T9
 for 57397 <at> debbugs.gnu.org; Tue, 30 Aug 2022 21:32:43 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1661909550;
 bh=Sv7QDlkbI6oqDfesXlCEUaGFfbgdqxtZ5Xy0UkGmmbE=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=ASSsr3arzqsF9TLFLKDfNwBB/d60F3mYNAuMHJKZRarT/fXcYXmNp8x0LLBrRfsHd
 jWWvWG/GvI8EsggB78iuzLUwB3kPMVQNtJN0v1yX3A2hEXH+ZUgjVeJ7/LW2glmRkv
 I9PzZDRrBBkxjYg+r2AjMJ+GHlJI+5As23gA7GAI=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.57.248.18]) by smtp.web.de (mrweb105
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1N3ouw-1pShC94384-00zi61; Wed, 31
 Aug 2022 03:32:30 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: cl-letf blindly macroexpands places
In-Reply-To: <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
 of "Sat, 27 Aug 2022 10:48:17 -0400")
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN> <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
Date: Wed, 31 Aug 2022 03:32:28 +0200
Message-ID: <87sfldmc43.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Provags-ID: V03:K1:ERhtt+2o3cjP1hieHfh8po0yPWPro4Iv8tB3FUsV9igEGkefXNw
 JHd0F90nbv4Q4jsFHWD90Y9fq8ssJ/BQuNS9k38c+5/tptPKSG6WHxh1cZEHIy5a7/OGFxS
 pjdlNi78rNEF25qODOucLAsVcu5rFFgtURyz9kuISAQ+WeLQaE70j72W9BJf9jirmyDUBuW
 bFhZgeFxXIjet718kEOYg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:rAgGwyyAsAU=:Gc0bcqWksOz3kP09BegMd2
 Hl8hLDIMcSs87yV+ERz80wVCpvddch8r+JITwJSG8tbgCMekGf6MuxPAYXagfWs8RwvHOv5Tq
 hmBb5xpQsk9WGbHZhMt/UB6unSChO08J8lfljIJrlqQFg2YEq+6bLflGkoePo/kfcxxTQi6yb
 bur+YtsLv5s6U1onG0enaUNl3SOSXNHX1G9AouZJl5KFVYWEQS4kF0fRml4qiQikM/ME6d56o
 aRfKm4wvcUEkcnZsWk71t5euJc1k87h5PjkEVuYx94FS2osrg3l2zqwQOWooYRHdAPAE4JmTG
 TYFtC9NK43dr4gYGjJ53kmnhk0eQ0DH5Ima7cB5dri3NtwyC9SCSQJOPn+l5zcXgikF3VQ0+I
 Q+zdr1ruUf0zgD1O6/UhcndvB2fkPgrBXjI+3z/xnnHlMIlIs1v7+Nm+h53RUZFJW+Q92LQQu
 gSmQ9FNcdD527e5gXukSyqwITLwCnIVPiz+jfEgr/f6GFa9MWu9kd5fhXlnlb/HitJsJSEqwz
 DOA8AFFFurJxxh5dMQ+O/NBimdkyAVpQPpzjc2KlJ24MWBQxjDTXh8ebFqZXtBo2AjSo4JWoJ
 bOBtUbmcVV6Y+s5Bn3Znc2wMkw1moorLv+LDTXAm7cOdEbqjI4NofU6pez9QxyN4BKti9ICGT
 ddHl5haDjHiG/UOKXvxJktwNTRC4pOLtTqUEhoBJdnRfceHUsUgtYMrGuxxNlxXYgySWpqjuz
 aj3sSKdqSM1KdzL+sdo2+f7KWEKwAomN14JMDO+0Hh2mqcJyGGtMY15oP7pN7jZ8t9l9oRCX2
 4yZmprWED499whvk00+no0Ixm/dki51c9uphIR1S4qXo9hwpPezvFtzT8hOJQqIz9tKfH0Rj/
 qfyhy7rXvrPQPVBxiyq1PqfD6bCPFOKXs/NAY/XLeIbsRH1chV8VQatgdRTrqIs0AzSLcgMem
 RWC95Q89BmVHfUKS9KRrjwdE5X+l5D4Uk0qxv+YHvkg5sqw6f+SUPgCW6ROVRjIe/u3BfQgs3
 qthm2IDGbQs66LvEiNj9eWQ3BG+oDPj13MjaTM0FIdBStIiz2Ck7Az8FHm5CVb+ju6RbrPYl2
 YMKnnRmZjJafcqHSrgRyIfB0CKp8YDqObcYq2pt0lPP1Mo985Neh3ALUw==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain

Stefan Monnier <monnier@HIDDEN> writes:

> > Was it necessary to really expand symbol macros to fix that bug, or is
> > the purpose only to handle the following `symbolp' test correctly?
>
> No the problem shows up in the `gv-letplace` that follows immediately,
> so by the time we get to the `symbolp` test it's too late.
> But I suspect that the better fix is to skip the macroexpand call here
> and to change `gv-get` so as to do a `macroexpand-1` call even if its
> arg is a `symbolp`.

Ok, you have obviously more insight here, so can you maybe...take over
this part?

> > [`gv-synthetic-place'] seems to work quite as well (using the same
> > body and gv-spec) when defined as a function.
>
> The only downside is that the code is less efficient (the getter has to
> construct the closure of the setter, then call `gv-synthetic-place`
> which then just throws it away) but that should be easy to fix with
> a compiler macro.

Ok - does this look correct?


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Turn-gv-synthetic-place-into-a-function.patch
Content-Transfer-Encoding: quoted-printable

=46rom 585981019e32ff4aa1a7ce4614428744d1b55332 Mon Sep 17 00:00:00 2001
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
Date: Wed, 31 Aug 2022 03:13:09 +0200
Subject: [PATCH] Turn gv-synthetic-place into a function

This fixes Bug#57397.

* lisp/emacs-lisp/gv.el (gv-synthetic-place): Make a function and add
trivial compiler macro to avoid decreasing efficiency.
=2D--
 lisp/emacs-lisp/gv.el | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

diff --git a/lisp/emacs-lisp/gv.el b/lisp/emacs-lisp/gv.el
index eaab6439ad..9c3f77d2cc 100644
=2D-- a/lisp/emacs-lisp/gv.el
+++ b/lisp/emacs-lisp/gv.el
@@ -532,13 +532,13 @@ plist-get
        (funcall do `(error . ,args)
                 (lambda (v) `(progn ,v (error . ,args))))))

-(defmacro gv-synthetic-place (getter setter)
+(defun gv-synthetic-place (getter setter)
   "Special place described by its setter and getter.
 GETTER and SETTER (typically obtained via `gv-letplace') get and
-set that place.  I.e. This macro allows you to do the \"reverse\" of what
-`gv-letplace' does.
-This macro only makes sense when used in a place."
-  (declare (gv-expander funcall))
+set that place.  I.e. this function allows you to do the
+\"reverse\" of what `gv-letplace' does.  This function only makes
+sense when used in a place."
+  (declare (gv-expander funcall) (compiler-macro (lambda (_) getter)))
   (ignore setter)
   getter)

=2D-
2.30.2


--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


BTW, I had trouble understanding the paragraph about the compiler-macro
declare specs in (info "(elisp) Declare Form"), in particular the calling
convention:

| [...] When encountering a call to the function, of the form =E2=80=98(FUN=
CTION
| ARGS...)=E2=80=99, the macro expander will call EXPANDER with that form as
| well as with ARGS...

not only because of the colons, but also because it's...wrong?  EXPANDER
is called with one argument, and the other formal arguments are
available (bound) to the corresponding argument forms, right?

Could you then maybe rephrase a bit [I don't want to, my English is not
good enough.  I'm able to do it but it always takes much too long to
find a good wording.]

TIA,

Michael.

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 27 Aug 2022 14:48:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Aug 27 10:48:34 2022
Received: from localhost ([127.0.0.1]:56770 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oRx6v-0008Ec-Oo
	for submit <at> debbugs.gnu.org; Sat, 27 Aug 2022 10:48:34 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:28506)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1oRx6s-0008EM-Ac
 for 57397 <at> debbugs.gnu.org; Sat, 27 Aug 2022 10:48:32 -0400
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 722894411C7;
 Sat, 27 Aug 2022 10:48:24 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id CE8B144115A;
 Sat, 27 Aug 2022 10:48:18 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1661611698;
 bh=c0Y6PfMqu1yS2n9Zt3IFhRCo5/94iWK6jxgKXyz+QsI=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=kqzVAvPiYDzHMRVP8SA4q7fLjX4FGjJQCzMllicI6NWn/kBtLczBV4nSPXybIZh7G
 tJ9VeG/LznELgpmkjJCkzcNnaW/vr0nGnae37lon0FcutEu7ItDeZSnQprWAy9XxfK
 slMVX9jfPZjbTcGqk4Oxir2B1HaUFx/t+dkSssbNFR2ZXXBREpWBJy3MF12Mm99D8V
 9WEDyfyZJX+YkU7kKpo0ibcD2qCK9CwzayYmGVaCoz90IQmehts7XJuBkdzJyNOCK9
 P5Yb3VFRGxci8JxSA5xdx0QeP5q1WyN83VULgWF0BGKq/3ZVEHdAfJVlrOew87nFDs
 cYu1Qfhvooavw==
Received: from pastel (unknown [45.72.195.111])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 9D5291202DA;
 Sat, 27 Aug 2022 10:48:18 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: cl-letf blindly macroexpands places
In-Reply-To: <87leralavg.fsf@HIDDEN> (Michael Heerdegen's message of "Sat, 27
 Aug 2022 03:43:15 +0200")
Message-ID: <jwvwnatvjjb.fsf-monnier+emacs@HIDDEN>
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
 <87leralavg.fsf@HIDDEN>
Date: Sat, 27 Aug 2022 10:48:17 -0400
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.064 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> > Maybe it's enough to expand only symbol macros?
>> Yes, that should still cover the original need in bug#26073 without
>> breaking your use case.
> Was it necessary to really expand symbol macros to fix that bug, or is
> the purpose only to handle the following `symbolp' test correctly?

No the problem shows up in the `gv-letplace` that follows immediately,
so by the time we get to the `symbolp` test it's too late.
But I suspect that the better fix is to skip the macroexpand call here
and to change `gv-get` so as to do a `macroexpand-1` call even if its
arg is a `symbolp`.

>> But regardless of this, we should probably turn `gv-synthetic-place`
>> into a function so it's more robust.
> Why is it a macro?

Beats me.
I tried to ask the original author but he was not available for comments.

> Seems to work quite as well (using the same body and
> gv-spec) when defined as a function.

The only downside is that the code is less efficient (the getter has to
construct the closure of the setter, then call `gv-synthetic-place`
which then just throws it away) but that should be easy to fix with
a compiler macro.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 27 Aug 2022 01:43:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 26 21:43:28 2022
Received: from localhost ([127.0.0.1]:54894 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oRkrA-0002D9-82
	for submit <at> debbugs.gnu.org; Fri, 26 Aug 2022 21:43:28 -0400
Received: from mout.web.de ([212.227.17.11]:41331)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1oRkr8-0002Cv-Df
 for 57397 <at> debbugs.gnu.org; Fri, 26 Aug 2022 21:43:26 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1661564597;
 bh=M+HGEKaDTxeg3PuHWXtFs8H4Skh5MPHAF0bo5YRUCbI=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:In-Reply-To:References:Date;
 b=JJIXDn6rRkGIxxqB7MrI0RFTeXf9HsrzAWTXmP3KxR86agKdw+M2t/X5PihTjRwFr
 +P5UuQR+7EVQD9h5ryIPIVu8UFbmkDK6JtD89LnINUxvn7CunZHmwP994KrtycRes7
 o4kv7XF4hDab2eKX5FvTWwoCoSZSY2zSsRdi/Q3M=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.57.248.18]) by smtp.web.de (mrweb105
 [213.165.67.124]) with ESMTPSA (Nemesis) id 1MsrdC-1pGQdI3t4C-00szwj; Sat, 27
 Aug 2022 03:43:16 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
Subject: Re: cl-letf blindly macroexpands places
In-Reply-To: <jwva67s2kd6.fsf-monnier+emacs@HIDDEN> (Stefan Monnier's message
 of "Thu, 25 Aug 2022 15:33:45 -0400")
References: <877d2xdjdi.fsf@HIDDEN> <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
Date: Sat, 27 Aug 2022 03:43:15 +0200
Message-ID: <87leralavg.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:remUPLMcodxCuIvzAUWfc+GOmCILpmvZJtH6OLk3MeZ42Qh7dil
 V1bZtD4fF9FpezbTcI23t/x/TY7or8Bs7Rn7o2IjS7UQw6yERbKY+7uNY8hQBQpI3e2Ic5y
 mOlV2VJdCYPNS9237mUCQzVMovaQOi09PjVq/G2kpz7hz7e/hyU6DmOi0h/ldgmbWa+fiYT
 eMKQ4+ucJYyJKia3cqpbw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:A7TKJLirbKw=:E656ifnvSS1nNRpHnQ6WNb
 JdxNosvKt1/eedZOSbrBkU8rCA9rhyRzXiZe/dFe7aR6oyWeRa7lBXVASNWf+QTyUnnZomIVE
 cHg7JznpGp3K2aDtXBAbfWpTC8VrS7hQ5oCEOnZbPzB9IDY18pkliDUGb6xCF9AqlmEENDmSh
 vt8u5ZuDMA+NFN+5SI0ESsj82eNdI3wSBhfQi951/9zoFR35dGKdEUfu7CQp+jGEKQOOzgRfO
 W7qwXmzmg93cz1vkska3+5mjFuTaJPg4lphYvN3W4tv7ze8+4tXfddNpFtv8YVELYk6pMaNG3
 1IHMxoJFEJMUIdRySQyia661Li7LIAVgkr9VCQdnamrOEGmjGMTQB2CJvzvs/XSCrgqjx+pAR
 SxWlamzZ4dDF9hfHt2v14hV2OPsjFV3+9w8H1OEHHsIRvnJsQ5t/gIUUr3+viabKxMQ/eaTqT
 /h+U8zJidYe0MuS45qyg5z7JqRJGeJQM8HRMEKBSX+uOG0kXuaZuXsNoXvICaB0UHpSP4g3zl
 iU43sVPqxQdzmkSe6Gs7q7dno+Z76ONVMH6Oa0N35TKawS4D4uZcvH0ZCfcEvYL+j5i2VZeCQ
 kB61Al4T1zpfAmDh8+qk1hv/Tc4S3bIZGvW+x8a1V5ibSKQtE9bmvvzoqkDoC39fzrzd3gKYA
 BUdfNs4qI8XrJqx2+4Tc4eMEVFa6ussJzH4cj6YiIZmZOj4ZmPZAD6IClDLqYpZGu6SNASvmL
 R3vhUEZplqM12qbzVZNEB/BoPwfweZqEfsQitlkdNRjgIXJw6o0YeNfM3m+DoTyCuQrCxZ2y5
 jJIumAVCxdj3pczJz/sv0ie0rRJdO6s5pe2lakcVlEwmyEBvSUm+8Os0nzdTsjE8k/4TZMzcs
 JyyveelOcHpLQFdkTMPy1nMULZ4bTE+0K5JWmvzGXUlWeeMFRT11gelwPVs5q7Hlv70eK3Qwx
 cDA30CZaKORrnu942r0lSwmsjDIYOLXLQXcDMvtnvWpVACYsR84MOtlZwdEoj0Oc4s9OTEWDO
 rLYDKtz1S0vhUiCs+FuW/1cXa1gSwHnpvXgQFyUQiCWbJvAbM2fj1yDmUfy6VA5cKpYKg1nZu
 l+MShmlORCzDFMyVPjkvI5WYopqKFxPSDBTPjVohiFjkNB8+qDTcRAErQ==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Stefan Monnier <monnier@HIDDEN> writes:

> > Maybe it's enough to expand only symbol macros?
>
> Yes, that should still cover the original need in bug#26073 without
> breaking your use case.

Was it necessary to really expand symbol macros to fix that bug, or is
the purpose only to handle the following `symbolp' test correctly?

> But regardless of this, we should probably turn `gv-synthetic-place`
> into a function so it's more robust.

Why is it a macro?  Seems to work quite as well (using the same body and
gv-spec) when defined as a function.

Michael.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at 57397 <at> debbugs.gnu.org:


Received: (at 57397) by debbugs.gnu.org; 25 Aug 2022 19:34:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Aug 25 15:34:03 2022
Received: from localhost ([127.0.0.1]:51349 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oRIc7-0001eI-8W
	for submit <at> debbugs.gnu.org; Thu, 25 Aug 2022 15:34:03 -0400
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:7864)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1oRIc5-0001dm-0w
 for 57397 <at> debbugs.gnu.org; Thu, 25 Aug 2022 15:34:01 -0400
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 942568007C;
 Thu, 25 Aug 2022 15:33:54 -0400 (EDT)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 7AAA78043C;
 Thu, 25 Aug 2022 15:33:52 -0400 (EDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1661456032;
 bh=F5D2Wo6J8dElmp4kqmjiqPbJ6IzFhSEdGCpWoNF7kuM=;
 h=From:To:Cc:Subject:In-Reply-To:References:Date:From;
 b=nsFVo9vPhiRgs+54xI0kdFOVZwfoGmKVX7JurLszTrlPbrM51xOI7uPb2JSr/+0FR
 0/d+YHuTVFi8zRlcWEvJ0k35+nDdMr0TRSWDxTEDDJxo+UJfv79gBzOFohiOvidsgI
 Z2XDAaMAS6R2Td9ug8Vs4eRn2opXnkok1O5q7tEysDsWFULJ7KUNzj0VuKePb4zhvP
 A8iIQAKoe/PcuSGMqQh6Q/EwiiX9OXTYDBDhMRbhlZ9kagjhuMtNnz0ue80VV6sZu7
 c6t6UMit1BmDIP4pPenaTTFfCjv5ekR2EtuM4Nrim290z9+nvQWZTrA6VAnBl/+TmG
 d7r3IJcryUikA==
Received: from alfajor (66-163-28-139.ip.tor.radiant.net [66.163.28.139])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id EAD741204E9;
 Thu, 25 Aug 2022 15:33:51 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Michael Heerdegen <michael_heerdegen@HIDDEN>
Subject: Re: cl-letf blindly macroexpands places
In-Reply-To: <877d2xdjdi.fsf@HIDDEN> (Michael Heerdegen's message of "Thu, 25
 Aug 2022 06:42:17 +0200")
Message-ID: <jwva67s2kd6.fsf-monnier+emacs@HIDDEN>
References: <877d2xdjdi.fsf@HIDDEN>
Date: Thu, 25 Aug 2022 15:33:45 -0400
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/29.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain T_SCC_BODY_TEXT_LINE    -0.01 -
X-SPAM-LEVEL: 
X-Spam-Score: 1.3 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: > to support symbol macros better: > > #+begin_src emacs-lisp
 > (defun cl--letf (bindings simplebinds binds body) > ; ; It's not quite clear
 what the semantics of cl-letf should be...10.. > (if (null b [...] 
 Content analysis details:   (1.3 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 3.6 RCVD_IN_SBL_CSS        RBL: Received via a relay in Spamhaus SBL-CSS
 [66.163.28.139 listed in zen.spamhaus.org]
 -2.3 RCVD_IN_DNSWL_MED      RBL: Sender listed at https://www.dnswl.org/,
 medium trust [132.204.25.50 listed in list.dnswl.org]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 57397
Cc: 57397 <at> debbugs.gnu.org, Lars Ingebrigtsen <larsi@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.3 (/)

> to support symbol macros better:
>
> #+begin_src emacs-lisp
> (defun cl--letf (bindings simplebinds binds body)
>   ;; It's not quite clear what the semantics of cl-letf should be...10..
>   (if (null bindings)
>       (if (and (null binds) (null simplebinds)) (macroexp-progn body)..20..)
>     (let* ((binding (car bindings))
>            (place (macroexpand (car binding) macroexpand-all-environment)));<--!!
>       (gv-letplace (getter setter) place..12..))))
> #+end_src
>
> I think this is an error in the general case.  It's at least always
> wrong when (car PLACE) is a macro name with a gv spec defined.

Indeed, defining a gv spec for a macro is fiddly.

> Maybe it's enough to expand only symbol macros?

Yes, that should still cover the original need in bug#26073 without
breaking your use case.

But regardless of this, we should probably turn `gv-synthetic-place`
into a function so it's more robust.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Aug 2022 04:42:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Aug 25 00:42:34 2022
Received: from localhost ([127.0.0.1]:48581 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1oR4hO-0003pv-Cj
	for submit <at> debbugs.gnu.org; Thu, 25 Aug 2022 00:42:34 -0400
Received: from lists.gnu.org ([209.51.188.17]:43838)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <michael_heerdegen@HIDDEN>) id 1oR4hJ-0003ph-QK
 for submit <at> debbugs.gnu.org; Thu, 25 Aug 2022 00:42:33 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:41586)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <michael_heerdegen@HIDDEN>)
 id 1oR4hJ-00058h-Ko
 for bug-gnu-emacs@HIDDEN; Thu, 25 Aug 2022 00:42:29 -0400
Received: from mout.web.de ([212.227.15.4]:36603)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <michael_heerdegen@HIDDEN>)
 id 1oR4hH-0000p1-Q6
 for bug-gnu-emacs@HIDDEN; Thu, 25 Aug 2022 00:42:29 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1661402539;
 bh=ePGmqdGY6nvtUbLIkgDCu8ftZ8L7AtlXgUhZj7JdA5w=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:Date;
 b=JdKNP1p7eqyPe70NHew1yWE1+GucXtEXistyeErrqxDYIrpVsU/UoA/flDYc75+Lm
 bLEOlwvft3VWMbNalSQIC5N8n1cVTFSsmUxxT9NdEY9uDd7ODLW8J0TzSFoddoZwhP
 o07DLXxaI1qGnYT+XISvGeIDOQ0btQRq+qqvTrkg=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from drachen.dragon ([84.57.248.18]) by smtp.web.de (mrweb005
 [213.165.67.108]) with ESMTPSA (Nemesis) id 1Mgzeb-1p5sUp3kSr-00h13b; Thu, 25
 Aug 2022 06:42:18 +0200
From: Michael Heerdegen <michael_heerdegen@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 29.0.50; cl-letf blindly macroexpands places
Date: Thu, 25 Aug 2022 06:42:17 +0200
Message-ID: <877d2xdjdi.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:Nuf46WKUER64AlBNRmKTJDtSPElXgDcUind2qlBRLXqx3tv17J1
 B1WnzeE3jEqJZX896GZ3AbFNkW/iSau3twG9z6pfZnbVDPajkmF8Y8FcPGIuo6/vO/B/YfE
 sJ3wfiKRJisLkNfnpyfUwbs7DOFQEdMzy/qWVuRVXU7IvJTrYBjHFaWDtT4xiEoHKZ1fsdT
 2AReSVjHGNZ5zELPy7IiA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:RTYroL8rGWc=:kxyejes7JF/o+MQSYZitHI
 6ZLhKqYqqmNDdamMaXoCIU7Xj7ANW4UMxMR1x9lx8fVhgWwJnz1FYKpW3GVAT2q5J33b6ELY4
 cKOe3q29yGvhL3//KOA4HJ4PoUvpm9MfOQ7Bt4PCimKgm7pG6UOBbF+4Ggx1sIS8Jp/tnrQ7E
 NouKRI4AVLxzOo9ypswXtd+KAfzwDfC7to7Jz56UUFhTfLPbxMTY645HhBgMFJTZHOQ9dzD0k
 PoR8wcbRUfSVBnGtnQmQgzmyiPWC3Kg+sf0GCvUR/NuM2eaHOmb3NQvl3Wei9keCHy0sezJj8
 tPd1F89HxOq8ayRrqnhNaKMJ/SMHpSRLHB7gE65pH1mZudcHp9aUCdJkolV8iXzuzLx643UiU
 8svEOA1OqYFY+g09Q+g2O0+IO6FMiSSdvAF+nEygvbzzd80lWbbN9RWPimhI5AA28+8rmRmjW
 Mhgw1G0j6oqEoOshBXyJcsocl6VsKzTa0mfudupE6RKWdCX6cSFrKha4TnZ9GLnsqhGuwplRJ
 WW0hbAgakPr5PpjXVeOotxY8xpihXLTOQ/GtYn0dNYasgEdeiK9V6+mFtoU2biwTiFuJ4Lmwn
 maIX8kMqgtCNTwB4SU1rZgV3+eIofUUb5cqsAuNePmHrmt9xk/G+jKwtmGehNpePy/kRbo6FT
 zYV0heUNN8x/9CaTeog9LyS8uOpRIf3flzQ+Bpp+vS82ryVJR4b0va1ycwrvQwUeFfINpVtI0
 aL3DD1D60JSdVuIFfGvFz0u9F7L5SNpZ+0FbF1enItB7i9RnuqjJ5Mj1XrIf9HbAQ5K29V8fb
 sofRgzGh/gz0bukGDRuUdPKIeAhRXRSFRXPiKNUhih3MmBR5at79Hedc/SGnn7JQ5CYvBdjiy
 Fzq1z978190WJboa+VEWbJmnGciwiPBoQriPK8N3mDUxGWkbP0VlkhJ2tfAdh4KoutD/sxcK7
 ULWDI3P2wsN1m2sqah8CClpoKayOfD/OMvW3tYIpBkkiHQ3ffqYp0ZfeZtXwSZ0ezGO5tYa+r
 +6tcQRYQSIfs3IPjBfpKENtFnrgxUTUYyteunXIfu+5K2TT6f4OVnKanl4EuuMqMljrMmlz7A
 FT7y8bor+fuHZTnEtQnQKc9OpPYaMyl9vtGZSuVQctoAOVGpd8tj6Dj5w==
Received-SPF: pass client-ip=212.227.15.4;
 envelope-from=michael_heerdegen@HIDDEN; helo=mout.web.de
X-Spam_score_int: -27
X-Spam_score: -2.8
X-Spam_bar: --
X-Spam_report: (-2.8 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_LOW=-0.7, RCVD_IN_MSPIKE_H3=0.001, RCVD_IN_MSPIKE_WL=0.001,
 SPF_HELO_NONE=0.001, SPF_PASS=-0.001,
 T_SCC_BODY_TEXT_LINE=-0.01 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: 0.2 (/)
X-Debbugs-Envelope-To: submit
Cc: Lars Ingebrigtsen <larsi@HIDDEN>,
 Stefan Monnier <monnier@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)


Hello,

background: to get rid of warnings about the recently obsoleted
generalized variables in my init file... because I'm lazy and wanted to
try (and there were only two) I blindly replaced them with synthetic
places - like this:

#+begin_src emacs-lisp
(defun test1 (b query)
  (cl-letf (((buffer-local-value 'buffer-save-without-query b)
             (or buffer-save-without-query query)))
    (with-current-buffer b (save-buffer))))
;; ~~>
(defun test2 (b query)
  (cl-letf (((gv-synthetic-place
              (buffer-local-value 'buffer-save-without-query b)
              (lambda (v) `(setq-local buffer-save-without-query ,v)))
             (or buffer-save-without-query query)))
    (with-current-buffer b (save-buffer))))
#+end_src

[ I know it is an nonsense example wrt what it does and how it does it,
that doesn't matter. ]

This should get rid of the warning - but in this case it doesn't (in
the other it did).  The reason is that Stefan made cl-letf (the helper
cl--letf more precisely), macroexpand each place:

| 91a7f934ac * lisp/emacs-lisp/cl-macs.el: Fix bug#26073.

to support symbol macros better:

#+begin_src emacs-lisp
(defun cl--letf (bindings simplebinds binds body)
  ;; It's not quite clear what the semantics of cl-letf should be...10..
  (if (null bindings)
      (if (and (null binds) (null simplebinds)) (macroexp-progn body)..20..)
    (let* ((binding (car bindings))
           (place (macroexpand (car binding) macroexpand-all-environment)));<--!!
      (gv-letplace (getter setter) place..12..))))
#+end_src

I think this is an error in the general case.  Maybe it's enough to
expand only symbol macros?  It's at least always wrong when (car PLACE)
is a macro name with a gv spec defined.

TIA,

Michael.


In GNU Emacs 29.0.50 (build 2, x86_64-pc-linux-gnu, X toolkit, cairo
 version 1.16.0, Xaw scroll bars) of 2022-08-25 built on drachen
Repository revision: bd5b704447ac5ec0559a824209bb01b271d29959
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12011000
System Description: Debian GNU/Linux 11 (bullseye)

Configured using:
 'configure --with-x-toolkit=lucid'





Acknowledgement sent to Michael Heerdegen <michael_heerdegen@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#57397; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 28 Sep 2022 18:30:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.